<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
   "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<!--
  AppenderConfig.jsp

  Copyright 2005 Chris Schultz - www.christopherschultz.net

  Allows you to change the configuration for Appenders defined
  using the log4j package.

  Please see the Creative Commons license at the end of this file
  for licensing information. The plain-English version of the license
  is "do whatever you want with this, just give me some credit".

  Enjoy!
-->
<%@page
    import="
	java.util.Collection,
	java.util.Enumeration,
	java.util.Iterator,
	java.util.HashSet,
	java.util.HashMap,
	java.util.Map,
	org.apache.log4j.Appender,
	org.apache.log4j.AppenderSkeleton,
	org.apache.log4j.LogManager,
	org.apache.log4j.Logger,
	org.apache.log4j.Level
    "
%>
<%@ include file="htmlescape.jsp" %>
<%!
    Level[] levels = { Level.toLevel("OFF"),
		       Level.toLevel("FATAL"),
		       Level.toLevel("ERROR"),
		       Level.toLevel("WARN"),
		       Level.toLevel("INFO"),
		       Level.toLevel("DEBUG"),
		       Level.toLevel("ALL") };

    Appender getAppender(Logger logger, String appenderName)
    {
	HashSet s = new HashSet();

	// Get all the appenders for THIS logger
	Appender appender = logger.getAppender(appenderName);
	if(null != appender)
	    return(appender);

	if(logger.getAdditivity())
	{
	    for(Enumeration e = LogManager.getCurrentLoggers(); e.hasMoreElements(); )
	    {
		Logger l = (Logger)e.nextElement();
		appender = l.getAppender(appenderName);
		if(null != appender)
		    return(appender);
	    }
	}

	return(null);
    }
%>
<%
    String appenderName = request.getParameter("appender");
    String appenderLabel = htmlescape(appenderName);

    String loggerName = request.getParameter("logger");
    if(null == loggerName || "".equals(loggerName.trim()))
	loggerName = "[root]";
    String loggerLabel = htmlescape(loggerName);

    Logger logger;
    if("[root]".equals(loggerName))
	logger = Logger.getRootLogger();
    else
	logger = LogManager.exists(loggerName);

    String op = request.getParameter("op");
    if("modify_appender".equals(op))
    {
	if(null != logger)
	{
	    Appender appender = getAppender(logger, appenderName);

	    if(null != appender && appender instanceof AppenderSkeleton)
	    {
		String newThreshold = request.getParameter("threshold");
		if("none".equals(newThreshold))
		    ((AppenderSkeleton)appender).setThreshold(null);
		else
		    ((AppenderSkeleton)appender).setThreshold(Level.toLevel(newThreshold));
	    }
	}
    }
%>
<!--
<rdf:RDF xmlns="http://web.resource.org/cc/"
    xmlns:dc="http://purl.org/dc/elements/1.1/"
    xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
<Work rdf:about="">
   <dc:title>AppenderConfig.jsp</dc:title>
   <dc:date>2005</dc:date>
   <dc:description>A server&#45;side JSP which allows users to modify log4j appenders while the server is running.
</dc:description>
   <dc:creator><Agent>
      <dc:title>Christopher Schultz</dc:title>
   </Agent></dc:creator>
   <dc:rights><Agent>
      <dc:title>Christopher Schultz</dc:title>
   </Agent></dc:rights>
   <dc:type rdf:resource="http://purl.org/dc/dcmitype/Interactive" />
   <license rdf:resource="http://creativecommons.org/licenses/by-sa/2.0/" />
</Work>

<License rdf:about="http://creativecommons.org/licenses/by-sa/2.0/">
   <permits rdf:resource="http://web.resource.org/cc/Reproduction" />
   <permits rdf:resource="http://web.resource.org/cc/Distribution" />
   <requires rdf:resource="http://web.resource.org/cc/Notice" />
   <requires rdf:resource="http://web.resource.org/cc/Attribution" />
   <permits rdf:resource="http://web.resource.org/cc/DerivativeWorks" />
   <requires rdf:resource="http://web.resource.org/cc/ShareAlike" />
</License>

</rdf:RDF>
-->
<html lang="en">
<head>
    <title>Appender Configurator</title>
    <style type="text/css">
	body { font-family:sans-serif; }
	h1 { text-align:center; font-size:x-large; }
	h2 { font-size:large; }
	fieldset { background-color:#e0e0e0; padding-top:1em; margin-bottom:1em; }
	fieldset legend { font-size:medium; font-weight:bold; border:2px groove ThreeDFace; background-color:#e0e0e0; padding:0.4ex 1ex 0.4ex 1ex; }
	label[for] { cursor:pointer; }
	span.accelerator { text-decoration:underline; }
	label { float:left; width:5em; margin-right:1em; }
	.separator { clear:both; }
	.logger-name { font-family:monospace; }
	.no-such-logger { font-family:monospace; color:red; }
    </style>
</head>
<body>
    <h1>Appender Configurator</h1>
<%
    if(null == logger)
    {
%>
    <p>
	No such logger: <span class="no-such-logger"><%= loggerLabel %></span>
    </p>
<%
    }
    else
    {
	Appender appender = getAppender(logger, appenderName);
	if(null == appender)
	{
%><font color="red">Unknown appender: <code><%= appenderName %></code> for logger <code><%= loggerLabel %></code></font><%
	}
	else
	{
%>
<div id="appender-info">
<fieldset>
    <legend>Appender Info</legend>

    <form method="get" action="<%= response.encodeURL(request.getRequestURI()) %>">
    <p>
	<label>Appender</label>
        <span class="appender-name"><%= appenderLabel %></span>
    </p>

    <div id="settings">
        <input type="hidden" name="logger" value="<%= loggerLabel %>" />
        <input type="hidden" name="appender" value="<%= appenderLabel %>" />
        <input type="hidden" name="op" value="modify_appender" />


	<label for="thresholdSelect" accesskey="l"><span class="accelerator">L</span>evel</label>
	<select id="thresholdSelect" name="threshold">
	    <option value="ALL">ALL</option>
<%
	if(appender instanceof AppenderSkeleton)
	{
	    AppenderSkeleton appSkel = (AppenderSkeleton)appender;

	    Level currentThreshold = (Level)appSkel.getThreshold();

	    if(null == currentThreshold)
		currentThreshold = Level.ALL;

	    for(int i=0; i<levels.length; ++i)
	    {
		Level level = levels[i];
		String levelLabel = htmlescape(level.toString());
%>		    <option value="<%= levelLabel %>"<% if(currentThreshold.equals(level)) { %> selected="selected"<% } %>><%= levelLabel %></option>
<%
	    }
	}
%>	</select>
	<br class="separator" />

	<label>Layout</label>
	(<i>coming soon</i>)
	<br class="separator" />

	<input type="submit" value="Change" />
    </div>
    </form>
</fieldset>
</div>
<%
	}
    }
%>

<p>
    <a href="<%= response.encodeURL("LogConfig.jsp") %>?logger=<%= loggerLabel %>">Return to logger</a>.
</p>

<hr />

<p class="license">
    <!-- Creative Commons License -->
    <a id="cc_license" rel="license" href="http://creativecommons.org/licenses/by-sa/2.0/">
    <img alt="Creative Commons License" style="border:none;"
        src="http://creativecommons.org/images/public/somerights20.gif" />
    </a>
    <!-- /Creative Commons License -->

    <a id="w3c_valid_xhtml" href="http://validator.w3.org/check?uri=referer"><img
          src="http://www.w3.org/Icons/valid-xhtml10"
          alt="Valid XHTML 1.0!" style="border:none;height:31px;width:88px;" />
    </a>

    <a id="w3c_valid_css" href="http://jigsaw.w3.org/css-validator/">
    <img style="border:0;width:88px;height:31px"
       src="http://jigsaw.w3.org/css-validator/images/vcss" 
       alt="Valid CSS!" />
    </a>
</p>
<p class="license">
    <!-- Creative Commons License -->
    This work is licensed under a <a id="cc_license_2" rel="license" href="http://creativecommons.org/licenses/by-sa/2.0/">Creative Commons License</a>.
    <!-- /Creative Commons License -->
</p>
</body>
</html>
